#Program to calculate derivative of DF

import numpy as np
#import pylab
import matplotlib.pyplot as plt
from lmfit import Minimizer, Parameters, fit_report
#from lmfit.models import  VoigtModel
from scipy.special import wofz
import time
from scipy import special
from scipy.interpolate import UnivariateSpline



data=np.loadtxt('data.dat',skiprows=3)   #skipping 3 lines of the header of Woollam mat files
xdata=np.flip(data[:,0])  #needed for the spline to have rising x-axis
ReData=np.flip(data[:,1])
ImData=np.flip(data[:,2])
#ydata=data[:,1] + 1j*data[:,2]    # making ydata a complex dielectric function


SmoothFactor=9
ReSpl=UnivariateSpline(xdata, ReData,k=5)
ReSpl.set_smoothing_factor(SmoothFactor/100)
ReDataSpl=ReSpl(xdata)
ReSecDer=ReSpl.derivative(n=2)
ReDataSecDer=ReSecDer(xdata)

ImSpl=UnivariateSpline(xdata, ImData,k=5)
ImSpl.set_smoothing_factor(SmoothFactor/100)
ImDataSpl=ImSpl(xdata)
ImSecDer=ImSpl.derivative(n=2)
ImDataSecDer=ImSecDer(xdata)



#data saving
FileData = open('smooth.dat', 'w+')
for i in range(len(xdata)):  print (xdata[i], "\t", ReDataSpl[i],"\t", ImDataSpl[i], file=FileData)

FileNameSD="SecDer"+str(SmoothFactor)+".dat"
FileDataSD = open(FileNameSD, 'w+')
for i in range(len(xdata)):  print (xdata[i],"\t",ReDataSecDer[i],"\t", ImDataSecDer[i], file=FileDataSD)

	
FileData.close()		

plt.plot(xdata, ReData, 'r-',label='ReData')	#vykresli nafitovane spektrum
plt.plot(xdata, ReDataSpl, 'b-',label='ReDataSpl')	#vykresli nafitovane spektrum
plt.plot(xdata, ImData, 'r-',label='ImData')	#vykresli nafitovane spektrum
plt.plot(xdata, ImDataSpl, 'b-',label='ImDataSpl')	#vykresli nafitovane spektrum

plt.legend(loc='upper right', shadow=False)
plt.show()
plt.plot(xdata, ReDataSecDer, 'r-',label='ReDataSplSecDer')	
plt.plot(xdata, ImDataSecDer, 'b-',label='ImDataSplSecDer')	
plt.legend(loc='upper right', shadow=False)
plt.show()




#raw_input("Press <ENTER> to finish")


